/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.6
        Device            :  PIC18F45K50
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.30 and above
        MPLAB 	          :  MPLAB X 5.40	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set LEDR aliases
#define LEDR_TRIS                 TRISBbits.TRISB0
#define LEDR_LAT                  LATBbits.LATB0
#define LEDR_PORT                 PORTBbits.RB0
#define LEDR_WPU                  WPUBbits.WPUB0
#define LEDR_ANS                  ANSELBbits.ANSB0
#define LEDR_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define LEDR_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define LEDR_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define LEDR_GetValue()           PORTBbits.RB0
#define LEDR_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define LEDR_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define LEDR_SetPullup()          do { WPUBbits.WPUB0 = 1; } while(0)
#define LEDR_ResetPullup()        do { WPUBbits.WPUB0 = 0; } while(0)
#define LEDR_SetAnalogMode()      do { ANSELBbits.ANSB0 = 1; } while(0)
#define LEDR_SetDigitalMode()     do { ANSELBbits.ANSB0 = 0; } while(0)

// get/set LEDV aliases
#define LEDV_TRIS                 TRISBbits.TRISB1
#define LEDV_LAT                  LATBbits.LATB1
#define LEDV_PORT                 PORTBbits.RB1
#define LEDV_WPU                  WPUBbits.WPUB1
#define LEDV_ANS                  ANSELBbits.ANSB1
#define LEDV_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define LEDV_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define LEDV_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define LEDV_GetValue()           PORTBbits.RB1
#define LEDV_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define LEDV_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define LEDV_SetPullup()          do { WPUBbits.WPUB1 = 1; } while(0)
#define LEDV_ResetPullup()        do { WPUBbits.WPUB1 = 0; } while(0)
#define LEDV_SetAnalogMode()      do { ANSELBbits.ANSB1 = 1; } while(0)
#define LEDV_SetDigitalMode()     do { ANSELBbits.ANSB1 = 0; } while(0)

// get/set LEDA aliases
#define LEDA_TRIS                 TRISBbits.TRISB2
#define LEDA_LAT                  LATBbits.LATB2
#define LEDA_PORT                 PORTBbits.RB2
#define LEDA_WPU                  WPUBbits.WPUB2
#define LEDA_ANS                  ANSELBbits.ANSB2
#define LEDA_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define LEDA_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define LEDA_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define LEDA_GetValue()           PORTBbits.RB2
#define LEDA_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define LEDA_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define LEDA_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define LEDA_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define LEDA_SetAnalogMode()      do { ANSELBbits.ANSB2 = 1; } while(0)
#define LEDA_SetDigitalMode()     do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set RC2 procedures
#define RC2_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define RC2_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define RC2_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define RC2_GetValue()              PORTCbits.RC2
#define RC2_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define RC2_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define RC2_SetAnalogMode()         do { ANSELCbits.ANSC2 = 1; } while(0)
#define RC2_SetDigitalMode()        do { ANSELCbits.ANSC2 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/